#define MAIN
#include "MicroGlut.h"
#include "GL_utilities.h"
#include "VectorUtils4.h"
#include "LittleOBJLoader.h"
#include "LoadTGA.h"
// uses framework Cocoa
// uses framework OpenGL

Model *m;
// Reference to shader program
GLuint program;
GLuint tex;
GLfloat offs = 1.0;
GLfloat scale = 1.0;

void init(void)
{
	// GL inits
	glClearColor(0.2,0.2,0.5,0);
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);
	glCullFace(GL_TRUE);
	printError("GL inits");
	
	// Load and compile shader
	program = loadShadersG("phong.vert", "tess.frag", "tess.gs");scale = 2.0;
	glUseProgram(program);
	printError("init shader");
	
	// Upload geometry to the GPU:
	m = LoadModel("Candide.obj");
	glUniform1f(glGetUniformLocation(program, "fix"), 1.0); // 1.0 or -1.0 - OBSOLETE
	glUniform1f(glGetUniformLocation(program, "offs"), 1.0/offs); // 1.0 or -1.0
	
	mat4 camMatrix = lookAt(0,0.0, 3.4, 0,0,0, 0,1,0);
	mat4 projectionMatrix = frustum(-0.4, 0.4, -0.4, 0.4, 1.0, 300.0);
	
	glUniformMatrix4fv(glGetUniformLocation(program, "camMatrix"), 1, GL_TRUE, camMatrix.m);
	glUniformMatrix4fv(glGetUniformLocation(program, "projMatrix"), 1, GL_TRUE, projectionMatrix.m);
	
	printError("init arrays");
}

GLfloat a = 0.0;

void display(void)
{
	printError("pre display");

	// clear the screen
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	a += 0.1;
	mat4 rot, trans, total;

	rot = Ry(sin(a/2));
	trans = T(0, 0, 0);
	trans = S(scale, scale, scale); // usually 1.0 (fix for bug in my CPNT code)
	total = rot * trans;
	glUniformMatrix4fv(glGetUniformLocation(program, "mdlMatrix"), 1, GL_TRUE, total.m);

	glUniform1f(glGetUniformLocation(program, "tweak"), (cos(a/10) + 1.0)/2.0);

	DrawModel(m, program, "inPosition", "inNormal", "inTexCoord");
	
	printError("display");
	
	glutSwapBuffers();
}

void key(unsigned char key, int x, int y)
{
	if (key == '+')
	{
		if (offs < 10.0)
			offs += 1.0;
		glUniform1f(glGetUniformLocation(program, "offs"), 1.0/offs); // 1.0 or -1.0
	}
	if (key == '-')
	{
		if (offs > 1.0)
			offs -= 1.0;
		glUniform1f(glGetUniformLocation(program, "offs"), 1.0/offs); // 1.0 or -1.0
	}
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitContextVersion(3, 2);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize(600, 600);
	glutCreateWindow ("gs tesselation example");
	glutDisplayFunc(display);
	init ();
	glutKeyboardFunc(key);
	glutRepeatingTimer(20);
	glutMainLoop();
	exit(0);
}
