#version 150

in	vec3 inPosition;
in	vec3 inNormal;
in	vec2 inTexCoord;

uniform mat4 mdlMatrix;
uniform mat4 camMatrix;
uniform mat4 projMatrix;

out vec3 norm;
out vec3 surf;
out vec2 texCoord;

void main()
{
	surf = vec3(camMatrix * mdlMatrix * vec4(inPosition, 1.0));
	gl_Position = projMatrix * camMatrix * mdlMatrix * vec4(inPosition, 1.0);
 
	mat3 normalMatrix1 = mat3(camMatrix * mdlMatrix);
	norm = normalMatrix1 * inNormal; // Phong

	texCoord = inTexCoord;
}
