#version 150

in vec3 exNormalG;
in vec2 texCoordG;
in vec3 surfG;
out vec4 outColor;
uniform float fix;

void main()
{
//	float fix = 1.0;

	float diffuseStrength;
	vec3 lightDirection = vec3(0.58, 0.58, 0.58); // Directional
	
	vec3 n = normalize(exNormalG);
	// Diffuse
	diffuseStrength = dot(n, lightDirection);
	diffuseStrength = clamp(diffuseStrength, 0.0, 1.0);
	
	// Specular
	vec3 reflectedLightDirection = reflect(-lightDirection, n);
	vec3 eyeDirection = normalize(-surfG); // eg -surfG men trianglarna r bakvnda
	
	float specularStrength = 0.0;
	if (dot(lightDirection, n) > 0.0)
	{
		specularStrength = dot(reflectedLightDirection, eyeDirection);
		float exponent = 200.0;
		specularStrength = max(specularStrength, 0.01);
		specularStrength = pow(specularStrength, exponent);
	}
	
	float level = diffuseStrength*0.5 + specularStrength*0.5;
//	float level = specularStrength;
	outColor = vec4(level, level, level, 1.0);
//	outColor = vec4(surfG.x, surfG.y, surfG.z, 1.0);
//	outColor = vec4(exNormalG.x, exNormalG.y, exNormalG.z, 1.0);
//	outColor = vec4(n.x, n.y, n.z, 1.0);
}
